## Apache Zeta Components Manual :: Docs For Class ezcDocumentBBCode

### Document::ezcDocumentBBCode

### Class ezcDocumentBBCode

Document handler for BBCode text documents.

BBCode are common in forum software and only provide a very basic set of markup directives. The implemented BBCode handler focusses on the BBCode implementation in the most common forum software: phpBB.

Just like in the forum software it can be extended with custom BBCode definitions.

Source for this file: /Document/src/document/bbcode.php

### Implements interfaces:

- ezcDocumentValidation

    ezcDocument
       |
       --ezcDocumentBBCode

Version: | //autogen//

### Member Variables

protected ezcDocumentBBCodeDocumentNode | `$ast` Asbtract syntax tree. The internal representation of BBCode documents.
protected string | `$contents` Plain BBCode contents as a string
protected array | `$plugins = array( )` Registered plugins Plugins are the best entry point for custom BBCodes, so you may register custom plugin classes using the class method registerPlugin().

### Inherited Member Variables

From ezcDocument
protected | `ezcDocument::$errors`
protected | `ezcDocument::$options`
protected | `ezcDocument::$path`

### Method Summary

public void | `createFromDocbook( $document )` Create document from docbook document
public ezcDocumentDocbook | `getAsDocbook( )` Return document compiled to the docbook format
public string | `getPluginHandler( $name )` Get plugin handler
public void | `loadString( $string )` Create document from input string
public void | `registerPlugin( $name , $class )` Register plugin handler
public string | `save( )` Return document as string
public mixed | `validateFile( $file )` Validate the input file
public mixed | `validateString( $string )` Validate the input string

### Inherited Methods

From ezcDocument
public ezcDocument | `ezcDocument::__construct()` Construct new document
public abstract void | `ezcDocument::createFromDocbook()` Create document from docbook document
public abstract ezcDocumentDocbook | `ezcDocument::getAsDocbook()` Return document compiled to the docbook format
public array | `ezcDocument::getErrors()` Return list of errors occured during visiting the document.
public string | `ezcDocument::getPath()` Get document base path
public void | `ezcDocument::loadFile()` Create document from file
public abstract void | `ezcDocument::loadString()` Create document from input string
public abstract string | `ezcDocument::save()` Return document as string
public void | `ezcDocument::setPath()` Set document base path
public void | `ezcDocument::triggerError()` Trigger visitor error

### Methods

#### createFromDocbook

void createFromDocbook( ezcDocumentDocbook $document )

Create document from docbook document

A document of the docbook format is provided and the internal document structure should be created out of this.

This method is required for all formats to have one central format, so that each format can be compiled into each other format using docbook as an intermediate format.

You may of course just call an existing converter for this conversion.

##### Parameters:

Name | Type | Description
--- | --- | ---
`$document` | ezcDocumentDocbook |

##### Redefinition of:

Method | Description
--- | ---
`ezcDocument::createFromDocbook()` | Create document from docbook document

#### getAsDocbook

ezcDocumentDocbook getAsDocbook( )

Return document compiled to the docbook format

The internal document structure is compiled to the docbook format and the resulting docbook document is returned.

This method is required for all formats to have one central format, so that each format can be compiled into each other format using docbook as an intermediate format.

You may of course just call an existing converter for this conversion.

##### Redefinition of:

Method | Description
--- | ---
`ezcDocument::getAsDocbook()` | Return document compiled to the docbook format

#### getPluginHandler

string getPluginHandler( string $name )

Get plugin handler

Get plugin handler class name for the specified name.

##### Parameters:

Name | Type | Description
--- | --- | ---
`$name` | string |

#### loadString

void loadString( string $string )

Create document from input string

Create a document of the current type handler class and parse it into a usable internal structure.

##### Parameters:

Name | Type | Description
--- | --- | ---
`$string` | string |

##### Redefinition of:

Method | Description
--- | ---
`ezcDocument::loadString()` | Create document from input string

#### registerPlugin

void registerPlugin( string $name , string $class )

Register plugin handler

Register a custom plugin handler for special plugins or overwrite existing plugin handlers. The plugins are specified by its (lowercase) name and the class name, which should handle the plugin and extend from ezcDocumentBBCodePlugin.

##### Parameters:

Name | Type | Description
--- | --- | ---
`$name` | string |
`$class` | string |

#### save

string save( )

Return document as string

Serialize the document to a string an return it.

##### Redefinition of:

Method | Description
--- | ---
`ezcDocument::save()` | Return document as string

#### validateFile

mixed validateFile( string $file )

Validate the input file

Validate the input file against the specification of the current document format.

Returns true, if the validation succeded, and an array with ezcDocumentValidationError objects otherwise.

##### Parameters:

Name | Type | Description
--- | --- | ---
`$file` | string |

##### Implementation of:

Method | Description
--- | ---
`ezcDocumentValidation::validateFile()` | Validate the input file

#### validateString

mixed validateString( string $string )

Validate the input string

Validate the input string against the specification of the current document format.

Returns true, if the validation succeded, and an array with ezcDocumentValidationError objects otherwise.

##### Parameters:

Name | Type | Description
--- | --- | ---
`$string` | string |

##### Implementation of:

Method | Description
--- | ---
`ezcDocumentValidation::validateString()` | Validate the input string

Documentation generated by phpDocumentor 1.4.3